import random
import time
random.seed(0)

from matcher_naive import *
from matcher_bmh import *
from matcher_dfa import *

def random_string(length, alphabet):
    n = len(alphabet)
    s = ''
    for i in range(0, length):
        s += alphabet[random.randint(0,n-1)]
    return s

def benchmark(pattern, text, alph):
    results = []

    t1 = time.time()
    M = matcher_naive(pattern, text)
    t2 = time.time()
    results.append(f'Naiv: {t2-t1:.4f} ({len(M)})')
    
    t1 = time.time()
    M = matcher_bmh(pattern, text, alph)
    t2 = time.time()
    results.append(f'BMH: {t2-t1:.4f} ({len(M)})')

    t1 = time.time()
    M = matcher_dfa(pattern, text, alph)
    t2 = time.time()
    results.append(f'DFA: {t2-t1:.4f} ({len(M)})')

    return results


alph1 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
alph2 = '01'
alph3 = 'ACGT'

alph = alph2

plen = 6
tlen = 10**7

### Zeitmessungen
txt = random_string(tlen, alph)
print(f'Alphabet: {alph}')
for k in range(4, 8):
    pat = random_string(plen, alph)
    print(f'Suche nach {pat} in einem Text der Länge {tlen}:')
    result = benchmark(pat, txt, alph)
    print(result)
